%
% FICHERO EJECUTABLE PARA LA ESTIMACIN DE LA ETTI
% CON PONDERACIONES IGUAL A LA INVERSA DE LA DURACIN
% 
% Program to estimate a zero-coupon curve
% It also computes forward rates, used as expectations of future term structures
%

load c:\Eriste2\Finanzas\etti\sep27.prn

n=size(sep27,1);
x=sep27(1:n-1,:);

pon='s';
M='N';

horizon = [5/365 1/12 3/12 6/12 1]';

%************ ETTI Estimation ************

[betasr cuadro res]=fedet(x,pon,M);
 
%*********************************************************

%***** CONVEXITY*****************************

betas=[betasr(1,1:4)]
[CONVEX]=convex(x,betas);

disp('  Duration   Convexity  Mkt.Price Tht.Price  IRR   price_bias    IRR_bias')
cuadro=[cuadro(:,1) CONVEX x(:,2) x(:,2)+cuadro(:,3) 100*cuadro(:,2) cuadro(:,3:4)]
% 
%*********************************************************
%*********** EXPECTATIONS OF FORWARD RATES *************************
%
plazos=[1/365 1/12 3/12 6/12 1 3 5 10 15]';
F1=[];

for i=1:size(plazos,1)
   plazo=plazos(i,1);
   f1=forward(plazo, horizon, betas);
   F1=[F1;f1];
end;

disp('Interest rate Expectations, using Forward rates as proxies')
disp('each column provides the Term Structure predicted for a given point in time in the future')
disp('Successive columns: A week, one month, three months, six months, one year from now')
[plazos 100*F1]
 
plot(cuadro(:,1),cuadro(:,6),'b*');
title('Price biases as a function of maturity')
pause;

matur = [1/365:.25:35]';
[zerocpn] = tipos(betas,matur);
plot(matur,zerocpn);
title('Estimated zero-coupon curve');
pause;

plot(plazos,F1);
title('Predicted Term Structures for tomorrow and next months')
pause;